/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package parser;

import static parser.Parser.computeActionTable;
import static parser.Parser.computeAllPossibleItems;
import static parser.Parser.computeGotoTable;

import java.io.FileNotFoundException;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Set;
import java.util.TreeSet;

/**
 *
 * @author edwajohn and bodipaul
 */
public class Main {

  public static int runTests() throws FileNotFoundException, IOException {
    Tests tests = new Tests();

    // TODO: uncomment tests as you develop code

     //------------------------------------------------------------
     // Goto table tests
     //------------------------------------------------------------
     {
//       Grammar grammar = new Grammar("data/Simple.cfg");
//       ArrayList<Item> items = computeAllPossibleItems(grammar.rules, grammar.follow);
//       HashMap<Set<Item>, Integer> state2name = new HashMap<>();
//       HashMap<Integer, Set<Item>> name2state = new HashMap<>();
//
//       HashMap<Integer, HashMap<String, Integer>> gotoTable = computeGotoTable(grammar, items, state2name, name2state);
//
//       // Should print something similar to:
//       //   State goal  list
//       //   0           2
//       //   1
//       //   2
//       //   3
//       printGotoTable(grammar, gotoTable);
//
//       // Use tree sets because they are sorted, so we can compare the toString()
//       // results.
//       String s0 = new TreeSet(name2state.get(0)).toString();
//       System.out.println(s0);
//       tests.test(s0.equals("[[goal -> ● list, EOF], [list -> ● FOO, EOF], [list -> ● FOO, FOO], [list -> ● list FOO, EOF], [list -> ● list FOO, FOO]]"));
//
//       int onList = gotoTable.get(0).get("list");
//       String s1 = new TreeSet(name2state.get(onList)).toString();
//       System.out.println(s1);
//       tests.test(s1.equals("[[goal -> list ●, EOF], [list -> list ● FOO, EOF], [list -> list ● FOO, FOO]]"));
//
//       tests.test(!gotoTable.get(0).containsKey("goal"));
//       tests.test(!gotoTable.get(onList).containsKey("goal"));
//       tests.test(!gotoTable.get(onList).containsKey("list"));
     }

     {
//       Grammar grammar = new Grammar("data/Paren.cfg");
//       ArrayList<Item> items = computeAllPossibleItems(grammar.rules, grammar.follow);
//       HashMap<Set<Item>, Integer> state2name = new HashMap<>();
//       HashMap<Integer, Set<Item>> name2state = new HashMap<>();
//
//       HashMap<Integer, HashMap<String, Integer>> gotoTable = computeGotoTable(grammar, items, state2name, name2state);
//
//       // Should print something similar to:
//       //   State goal  list  pair
//       //   0           1     2
//       //   1                 4
//       //   2
//       //   3           5     7
//       //   4
//       //   5                 10
//       //   6
//       //   7
//       //   8           11    7
//       //   9
//       //   10
//       //   11                10
//       //   12
//       //   13
//       printGotoTable(grammar, gotoTable);
//
//       String s0 = new TreeSet(name2state.get(0)).toString();
//       System.out.println(s0);
//       tests.test(s0.equals("[[goal -> ● list, EOF], [list -> ● list pair, EOF], [list -> ● list pair, OPAREN], [list -> ● pair, EOF], [list -> ● pair, OPAREN], [pair -> ● OPAREN CPAREN, EOF], [pair -> ● OPAREN CPAREN, OPAREN], [pair -> ● OPAREN list CPAREN, EOF], [pair -> ● OPAREN list CPAREN, OPAREN]]"));
//
//       String s1 = new TreeSet(name2state.get(gotoTable.get(0).get("list"))).toString();
//       System.out.println(s1);
//       tests.test(s1.equals("[[goal -> list ●, EOF], [list -> list ● pair, EOF], [list -> list ● pair, OPAREN], [pair -> ● OPAREN CPAREN, EOF], [pair -> ● OPAREN CPAREN, OPAREN], [pair -> ● OPAREN list CPAREN, EOF], [pair -> ● OPAREN list CPAREN, OPAREN]]"));
//
//       String s2 = new TreeSet(name2state.get(gotoTable.get(0).get("pair"))).toString();
//       System.out.println(s2);
//       tests.test(s2.equals("[[list -> pair ●, EOF], [list -> pair ●, OPAREN]]"));
//
//       tests.test(!gotoTable.get(0).containsKey("goal"));
//
//       int onList = gotoTable.get(0).get("list");
//       String s3 = new TreeSet(name2state.get(gotoTable.get(onList).get("pair"))).toString();
//       System.out.println(s3);
//       tests.test(s3.equals("[[list -> list pair ●, EOF], [list -> list pair ●, OPAREN]]"));
//
//       tests.test(!gotoTable.get(onList).containsKey("list"));
     }

     {
//       Grammar grammar = new Grammar("data/Expr.cfg");
//       ArrayList<Item> items = computeAllPossibleItems(grammar.rules, grammar.follow);
//       HashMap<Set<Item>, Integer> state2name = new HashMap<>();
//       HashMap<Integer, Set<Item>> name2state = new HashMap<>();
//
//       HashMap<Integer, HashMap<String, Integer>> gotoTable = computeGotoTable(grammar, items, state2name, name2state);
//
//       // Should print something like this:
//       // State goal  expr term  factor
//       // 0           2     3     5
//       // 1
//       // 2
//       // 3
//       // 4
//       // 5
//       // 6
//       // 7           13    14    16
//       // 8                 19    5
//       // 9                 20    5
//       // 10                      21
//       // 11                      22
//       // 12
//       // 13
//       // 14
//       // 15
//       // 16
//       // 17
//       // 18          28    14    16
//       // 19
//       // 20
//       // 21
//       // 22
//       // 23
//       // 24                29    16
//       // 25                30    16
//       // 26                      31
//       // 27                      32
//       // 28
//       // 29
//       // 30
//       // 31
//       // 32
//       // 33
//       printGotoTable(grammar, gotoTable);
//
//       String s0 = new TreeSet(name2state.get(0)).toString();
//       System.out.println(s0);
//       tests.test(s0.equals("[[expr -> ● expr MINUS term, EOF], [expr -> ● expr MINUS term, MINUS], [expr -> ● expr MINUS term, PLUS], [expr -> ● expr PLUS term, EOF], [expr -> ● expr PLUS term, MINUS], [expr -> ● expr PLUS term, PLUS], [expr -> ● term, EOF], [expr -> ● term, MINUS], [expr -> ● term, PLUS], [factor -> ● FLOAT, DIVIDE], [factor -> ● FLOAT, EOF], [factor -> ● FLOAT, MINUS], [factor -> ● FLOAT, MULTIPLY], [factor -> ● FLOAT, PLUS], [factor -> ● IDENTIFIER, DIVIDE], [factor -> ● IDENTIFIER, EOF], [factor -> ● IDENTIFIER, MINUS], [factor -> ● IDENTIFIER, MULTIPLY], [factor -> ● IDENTIFIER, PLUS], [factor -> ● INT, DIVIDE], [factor -> ● INT, EOF], [factor -> ● INT, MINUS], [factor -> ● INT, MULTIPLY], [factor -> ● INT, PLUS], [factor -> ● OPAREN expr CPAREN, DIVIDE], [factor -> ● OPAREN expr CPAREN, EOF], [factor -> ● OPAREN expr CPAREN, MINUS], [factor -> ● OPAREN expr CPAREN, MULTIPLY], [factor -> ● OPAREN expr CPAREN, PLUS], [goal -> ● expr, EOF], [term -> ● factor, DIVIDE], [term -> ● factor, EOF], [term -> ● factor, MINUS], [term -> ● factor, MULTIPLY], [term -> ● factor, PLUS], [term -> ● term DIVIDE factor, DIVIDE], [term -> ● term DIVIDE factor, EOF], [term -> ● term DIVIDE factor, MINUS], [term -> ● term DIVIDE factor, MULTIPLY], [term -> ● term DIVIDE factor, PLUS], [term -> ● term MULTIPLY factor, DIVIDE], [term -> ● term MULTIPLY factor, EOF], [term -> ● term MULTIPLY factor, MINUS], [term -> ● term MULTIPLY factor, MULTIPLY], [term -> ● term MULTIPLY factor, PLUS]]"));
//
//       String s1 = new TreeSet(name2state.get(gotoTable.get(0).get("expr"))).toString();
//       System.out.println(s1);
//       tests.test(s1.equals("[[expr -> expr ● MINUS term, EOF], [expr -> expr ● MINUS term, MINUS], [expr -> expr ● MINUS term, PLUS], [expr -> expr ● PLUS term, EOF], [expr -> expr ● PLUS term, MINUS], [expr -> expr ● PLUS term, PLUS], [goal -> expr ●, EOF]]"));
     }

     //------------------------------------------------------------
     // Action table tests
     //------------------------------------------------------------
     {
//       Grammar grammar = new Grammar("data/Simple.cfg");
//       ArrayList<Item> items
//               = computeAllPossibleItems(grammar.rules, grammar.follow);
//       HashMap<Set<Item>, Integer> state2name = new HashMap<>();
//       HashMap<Integer, Set<Item>> name2state = new HashMap<>();
//
//       HashMap<Integer, HashMap<String, Integer>> gotoTable
//               = computeGotoTable(grammar, items, state2name, name2state);
//       HashMap<Integer, HashMap<String, Action>> actionTable
//               = computeActionTable(
//                       state2name, name2state, gotoTable, grammar.startSymbol);
//
//       // Should print something like the following:
//       // State FOO
//       // 0     S 1
//       // 1     R list -> FOO
//       // 2     S 3
//       // 3     R list -> list FOO
//       printActionTable(grammar, actionTable);
//
//       Action a = actionTable.get(0).get("FOO");
//       tests.test(a.isShift());
//       int s1 = a.getState();
//       String s1str = new TreeSet(name2state.get(s1)).toString();
//       tests.test(s1str.equals("[[list -> FOO ●, EOF], [list -> FOO ●, FOO]]"));
//
//       Action a2 = actionTable.get(s1).get("FOO");
//       tests.test(a2.isReduce());
//       Rule r = a2.getRule();
//       System.out.println(r);
//       tests.test(r.toString().trim().equals("list -> FOO"));
     }

     {
//       Grammar grammar = new Grammar("data/Expr.cfg");
//       ArrayList<Item> items
//               = computeAllPossibleItems(grammar.rules, grammar.follow);
//       HashMap<Set<Item>, Integer> state2name = new HashMap<>();
//       HashMap<Integer, Set<Item>> name2state = new HashMap<>();
//
//       HashMap<Integer, HashMap<String, Integer>> gotoTable
//               = computeGotoTable(grammar, items, state2name, name2state);
//       HashMap<Integer, HashMap<String, Action>> actionTable
//               = computeActionTable(
//                       state2name, name2state, gotoTable, grammar.startSymbol);
//
//       TreeSet<Item> s0 = new TreeSet<>(name2state.get(0));
//       System.out.println(s0);
//       tests.test(s0.toString().equals("[[expr -> ● expr MINUS term, EOF], [expr -> ● expr MINUS term, MINUS], [expr -> ● expr MINUS term, PLUS], [expr -> ● expr PLUS term, EOF], [expr -> ● expr PLUS term, MINUS], [expr -> ● expr PLUS term, PLUS], [expr -> ● term, EOF], [expr -> ● term, MINUS], [expr -> ● term, PLUS], [factor -> ● FLOAT, DIVIDE], [factor -> ● FLOAT, EOF], [factor -> ● FLOAT, MINUS], [factor -> ● FLOAT, MULTIPLY], [factor -> ● FLOAT, PLUS], [factor -> ● IDENTIFIER, DIVIDE], [factor -> ● IDENTIFIER, EOF], [factor -> ● IDENTIFIER, MINUS], [factor -> ● IDENTIFIER, MULTIPLY], [factor -> ● IDENTIFIER, PLUS], [factor -> ● INT, DIVIDE], [factor -> ● INT, EOF], [factor -> ● INT, MINUS], [factor -> ● INT, MULTIPLY], [factor -> ● INT, PLUS], [factor -> ● OPAREN expr CPAREN, DIVIDE], [factor -> ● OPAREN expr CPAREN, EOF], [factor -> ● OPAREN expr CPAREN, MINUS], [factor -> ● OPAREN expr CPAREN, MULTIPLY], [factor -> ● OPAREN expr CPAREN, PLUS], [goal -> ● expr, EOF], [term -> ● factor, DIVIDE], [term -> ● factor, EOF], [term -> ● factor, MINUS], [term -> ● factor, MULTIPLY], [term -> ● factor, PLUS], [term -> ● term DIVIDE factor, DIVIDE], [term -> ● term DIVIDE factor, EOF], [term -> ● term DIVIDE factor, MINUS], [term -> ● term DIVIDE factor, MULTIPLY], [term -> ● term DIVIDE factor, PLUS], [term -> ● term MULTIPLY factor, DIVIDE], [term -> ● term MULTIPLY factor, EOF], [term -> ● term MULTIPLY factor, MINUS], [term -> ● term MULTIPLY factor, MULTIPLY], [term -> ● term MULTIPLY factor, PLUS]]"));
//
//       Action a = actionTable.get(0).get("FLOAT");
//       tests.test(a.isShift());
//       int s1 = a.getState();
//       String s1str = new TreeSet(name2state.get(s1)).toString();
//       System.out.println(s1str);
//       tests.test(s1str.trim().equals("[[factor -> FLOAT ●, DIVIDE], [factor -> FLOAT ●, EOF], [factor -> FLOAT ●, MINUS], [factor -> FLOAT ●, MULTIPLY], [factor -> FLOAT ●, PLUS]]"));
//
//       Action a2 = actionTable.get(s1).get("MINUS");
//       tests.test(a2.isReduce());
//       Rule r = a2.getRule();
//       System.out.println(r);
//       tests.test(r.toString().trim().equals("factor -> FLOAT"));
     }

    //------------------------------------------------------------
    // Output number of tests that succeeded
    //------------------------------------------------------------
    System.out.println(tests.getSuccesses() + "/" + tests.getN()
            + " tests succeeded");
    return tests.getFailures();
  }

private static void printGotoTable(Grammar grammar, HashMap<Integer, HashMap<String, Integer>> gotoTable) {
    System.out.print("State ");
    for (String nonterminal : grammar.nonterminals) {
      System.out.print(String.format("%-6s", nonterminal));
    }
    System.out.println();
    final int m = gotoTable.size();
    for (int i = 0; i < m; ++i) {
      System.out.print(String.format("%-6d", i));
      for (String nonterminal : grammar.nonterminals) {
        final int n = nonterminal.length() + 1;
        if (gotoTable.containsKey(i) && gotoTable.get(i).containsKey(nonterminal)) {
          System.out.print(String.format("%-6d", gotoTable.get(i).get(nonterminal)));
        } else {
          System.out.print("      ");
        }
      }

      System.out.println();
    }
  }

  private static void printActionTable(
          Grammar grammar, HashMap<Integer, HashMap<String, Action>> actionTable) {
    System.out.print("State ");
    for (String terminal : grammar.terminals) {
      System.out.print(String.format("%-6s", terminal));
    }
    System.out.println();
    final int m = actionTable.size();
    for (int i = 0; i < m; ++i) {
      System.out.print(String.format("%-6d", i));
      for (String terminal : grammar.terminals) {
        final int n = terminal.length() + 1;
        if (actionTable.containsKey(i) && actionTable.get(i).containsKey(terminal)) {
          System.out.print(String.format("%-6s", actionTable.get(i).get(terminal)));
        } else {
          System.out.print("      ");
        }
      }

      System.out.println();
    }
  }

  /**
   * @param args the command line arguments
   * @throws java.io.IOException
   */
  public static void main(String[] args) throws IOException {
    runTests();
  }

}
